// This program was used for the master's thesis of Tuva Østby and Jacob Jensen to test a prototype vaporizer at St. Olavs.
//

#include <AccelStepper.h>
#include <Wire.h>
#include <Adafruit_ADS1015.h>
#include "SDP.h"
#include "Wire.h"

SDP_Controller SDP800;

Adafruit_ADS1115 ads(0x48);
//AccelStepper stepper1(AccelStepper::DRIVER, 9, 8);
AccelStepper stepper1(AccelStepper::DRIVER, 3, 4);

int b;
char g;
char c;

float pressure;

int16_t adc0;
float les;
float samlet = 0;
float zeroCondition;
float CZPO;
float steps;
float bitADC = pow(2.0, 15.0)*(5.0/6.144); //
float airFlowPressure;
float constantDP = 0.018; // gir ml/s
float percentSevo = 0.03;
float sevoGasToLiq = 184.0; //
//float speedConstant = (3200)/(3.14159*4.699*4.699*1.0*0.001); // 
float speedConstant = (3200)/(3.14159*2.3875*2.3875*1.0*0.001);

int dir = 1;
float motorSpeed = 0;
float flowRate;
unsigned long nowTime;
float CZPO_function;
float flowSpiro;
float sevoGas;
float sevoLiq;
float stepsPerSecond;
float speedFactor = 1.0;//0.11;// 1.0;//3.0;//1.0;//1.5;//2.0;//1.0;

int x = 1;
int y = 0; 
int z = 1;
int u = 1;
int v = 0;
float Speed;
int h = 1;


// SDP
double DP, TMP; 


void setup(void) {
  Wire.begin();
  Wire.setClock(400000L);
  SDP800.begin();
  SDP800.getAddress();
  SDP800.startContinuousMeasurement(SDP_TEMPCOMP_MASS_FLOW, SDP_AVERAGING_TILL_READ);
    stepper1.setMaxSpeed(20000.0);
    ads.begin();
    ads.setSPS(ADS1115_DR_860SPS);
    Serial.begin(115200);

    //Her starter programmet
    CZPO = CZPOFunction(); //Kjører CZPO. TODO: legge inn funksjon som spør om MPX5010 eller MPX5004. Konstantene i CZPO kan da endres avhengig
    Serial.print("Zero-calibration for MPX5010 er: ");
    Serial.println(CZPO,8);
    delay(250);

    serialFunction(); //Sier hva programmet gjør
    
    while (!Serial.available()){
        //Do Absolutely Nothing until something is received over the serial port
    } 
}

void loop(void){
x = true;
if(Serial.available()){
    c = Serial.read();

    if (c == 'd'){
              //Serial.println("Set direction and pusher position");
              Serial.println("Direction: v: away from motor, h: towards motor");
              Serial.println("Position: o: motor end, l: far end");
              while (x = true){
              if(Serial.available()){
                  g = Serial.read();
                  if (g == 'v'){
                      dir = 1;
                      Serial.println("Direction set away from motor");
                      break;
                  }
                  if (g == 'h'){
                      dir = -1;
                      Serial.println("Direction set towards motor");
                      break;
                  }   
                  if (g == 'o'){
                      y = false;
                      z = true;
                      v = false;
                      u = true;
                      Serial.println("Pusher is positioned at motor end");
                      stepper1.setCurrentPosition(0);
                      break;
                  }  
                  if (g == 'l'){
                      y = true;
                      z = false;
                      v = true;
                      u = false;
                      Serial.println("Pusher is positioned at far end");
                      stepper1.setCurrentPosition(0);
                      break;
              }    
          }}      
      }
      
// FREMOVER
    if (c == 'm'){
        Serial.println("Moving away from motor at set speed until stop (s)");
        //Serial.println(stepper1.currentPosition()); //Debugging
        //stepper1.setCurrentPosition(0); // trenger ikke denne lenger eller?
        while (x == true){
            stepper1.setSpeed(1*motorSpeed);
            stepper1.runSpeed();
            if(Serial.available()){
                Serial.println("s: stop");
                c = Serial.read();
                if (c == 's'){
                    stopFunction();
                }
            }
        }
    }

// BAKOVER
    if (c == 'n'){
        Serial.println("Moving towards motor at set speed until stop (s)");
        //Serial.println(stepper1.currentPosition());
        while (x == true){
            stepper1.setSpeed(-1*motorSpeed);
            stepper1.runSpeed();
            if(Serial.available()){
                Serial.println("s: stop");
                c = Serial.read();
                if (c == 's'){
                    stopFunction();
                }
            }
        }
    }

// PRIMER BAKOVER
    if (c == 'r'){
        Serial.println("Primer pumpen (58 mm) mot motor");
        primerFunction(-1, 1.66666*3200.0);
        x = true;
        y = false; // går etterpå fra motor
        z = true;
        serialFunction();
    }

// PRIMER FREMOVER
    if (c == 'f'){
        Serial.println("Primer pumpen (58 mm) fra motor");
        primerFunction(1,1.666666*3200.0);
        y = true; // går etterpå mot motor
        x = true;
        z = false;
        serialFunction();
    }

// CZPO
    if (c == 'c'){  // Sampler CZPO
        Serial.println("Sampler CZPO");
        CZPO = CZPOFunction();
        serialFunction();
    }


// 8 SAMPLE AVG

    if (c == '2'){
        Serial.println("Leser ADC, 8-samples average og kjører"); 
        while (x == true){
            airFlowPressure = readADC(7); //Leser 8 samples
            steps = omregningFunction(airFlowPressure);
            //Serial.println(dir*steps*speedFactor); //Debugging
            stepper1.setSpeed(dir*steps*speedFactor); //Stiller inn speed. Må fikse dir så den endrer seg etter f.eks. 50 mm....
            stepper1.runSpeed(); //kjører motor ved hastighet
            if(Serial.available()){
                Serial.println("s: Stop, p: Print Gas Flow Rate");
                c = Serial.read();
                if (c == 's'){
                    stopFunction();
                }
                if (c == 'p'){
                    Serial.print("Gas Flow Rate (ml/s): ");
                    flowRate = gasFlowRateFunction();
                    Serial.println(flowRate);
                }
            }
        }
    }

// 16 SAMPLE AVG

    if (c == '3') {
        Serial.println("Leser ADC, 16-samples average og kjører"); 
        while (x == true){
            airFlowPressure = readADC(15); //Leser 8 samples
            steps = omregningFunction(airFlowPressure);
            stepper1.setSpeed(dir*steps*speedFactor);
            stepper1.runSpeed();
            if(Serial.available()){
                Serial.println("s: stop, p: print patient breath flow rate");
                c = Serial.read();
                if (c == 's'){
                    stopFunction();
                }
                if (c == 'p'){
                    Serial.print("Gas Flow Rate (ml/s): ");
                    flowRate = gasFlowRateFunction();
                    Serial.println(flowRate);
                } 
            }
        }
    }

// RAW
    if (c == '1') {
        Serial.println("Leser SDP og kjører"); 
        while (x == true){
            //les = ads.readADC_SingleEnded(0);
            //pressure = (((les/bitADC)-0.04)/0.09) - CZPO;
            //Serial.print("Pressure: "); //DEBUG
            //Serial.println(pressure,8); // DEBUG
            //delay(1000); // DEBUG
            //steps = omregningFunction(pressure);
            //Serial.print("Steps: ");// DEBUG
            //Serial.println(steps,8);// DEBUG
            initialBolusFunction();
            //fremTilbakeFunction();//steps); Tester dette
            //stepper1.setSpeed(dir*steps*speedFactor);
            //stepper1.runSpeed();
            if(Serial.available()){
                Serial.println("s: stop, p: print patient breath flow rate");
                c = Serial.read();
                if (c == 's'){
                    stopFunction();
                }
                if (c == 'p'){
                    Serial.print("Gas Flow Rate (ml/s): ");
                    flowRate = gasFlowRateFunction();
                    Serial.println(flowRate);
                }
            }
        }
    }

// SET SPEED
    if ( c == '0'){
        Serial.println("Sett hastighet til hva som helst under 3600.");
        while (x == true){
            if(Serial.available()){
                b = Serial.parseInt();
                if (b > 3200){
                    Serial.println("Under 3200 takk");
                    b = 0;
                    motorSpeed = 0;
                    Serial.println("Hastighet satt til: 0");
                }
                if (b == 0){
                    //Serial.println("Sett hastighet til hva du vil under 3600");
                }
                else {
                    motorSpeed = b;
                    float e = motorSpeed/3200.0;
                    Serial.print("Hastighet satt til: ");
                    Serial.print(motorSpeed);
                    Serial.println(" steps per sekund");
                    Serial.print("= ");
                    Serial.print(e);
                    Serial.println(" rotasjoner per sekund");
                    x = false;
                }
            }
          stepper1.setSpeed(motorSpeed);
          //Serial.println(motorSpeed); debugging
        }
    }
     
}//If serial available
}//Loop



//Funksjoner
void stopFunction()
{
  Serial.println("Stopper");
  x = false;
  y = false;
  z = false;
  serialFunction();
} //Funksjon


void primerFunction(int dir, float Speed)
{
    Serial.println("Primer");
    Serial.println(stepper1.currentPosition()); //Debugging
    stepper1.setCurrentPosition(0);
    Serial.println(stepper1.currentPosition()); //Debugging
    nowTime = millis();
    while (x==true){
        stepper1.setSpeed(dir*Speed);
        //stepper1.moveTo(3200*58); // beveger seg 58 mm, på 58 sek. Nei. Kjører tre-fire runder
        stepper1.moveTo(dir*185600); // (3200/sps)*58
        stepper1.setSpeed(dir*Speed);
        stepper1.runSpeedToPosition();
        //if ((millis() - nowTime) > 60000){
        //    Serial.println("Ferdig med priming");
        //    serialFunction();
        //    x = false;
        //}
        if(Serial.available()){
            Serial.println("s: stop");
            c = Serial.read();
            if (c == 's'){
                stopFunction();
            }
        }
    }
}//Funksjon


float CZPOFunction()
{
    for (int i=0; i <= 31; i++){
        les = ads.readADC_SingleEnded(0);
        zeroCondition = ((les/bitADC)-0.04)/0.09; //MPX5010DP
        samlet = samlet + zeroCondition;
        Serial.println(samlet);
    }
    CZPO_function = samlet/32;
    Serial.println(CZPO_function,8);
    samlet = 0;
    return CZPO_function;
}//Funksjon


void serialFunction()
{
    Serial.print("\n\n");
    Serial.println("0: speed, m: from motor, n: towards motor, d: set position");
    Serial.println("Prime: r: towards, f: from");
    Serial.println("c: CZPO, 1: raw");
    Serial.println("x, y, z");
    Serial.print(x);
    Serial.print(y);
    Serial.println(z);
    
}//Funksjon


float readADC(int averageNumber)
{
    for (int i=0; i <= averageNumber; i++){
        les = ads.readADC_SingleEnded(0);
        zeroCondition = (((les/bitADC)-0.04)/0.09) - CZPO; //MPX5010DP
        samlet = samlet + zeroCondition;
    }
    pressure = samlet/averageNumber;
    samlet = 0;
    //Serial.println("Ferdig avg");// DEBUG
    //Serial.println(pressure);// DEBUG
    return pressure;
    
}

float omregningFunction(float DiffPressure)
{
    //Serial.print("Diff pressure: ");// DEBUG
    //Serial.println(DiffPressure,8);// DEBUG
    //delay(1000);// DEBUG
    //flowSpiro = sqrt(DiffPressure*1000)*constantDP; //MPX (*1000 for å få Pa)
    stepper1.runSpeed();
    flowSpiro = sqrt(DiffPressure)/0.018; //SDP. ml/sek
    stepper1.runSpeed();
    //Serial.print("Air Flow: ");// DEBUG
    //Serial.println(flowSpiro);// DEBUG
    stepper1.runSpeed();
    sevoGas = (flowSpiro*percentSevo)/(1-percentSevo);
    stepper1.runSpeed();
    //Serial.print("sevogass: ");// DEBUG
    //Serial.println(sevoGas);// DEBUG
    //delay(1000);// DEBUG
    stepper1.runSpeed();
    sevoLiq = sevoGas/sevoGasToLiq;
    stepper1.runSpeed();
    //Serial.print("sevoliq: ");// DEBUG
    //Serial.println(sevoLiq);// DEBUG
    //delay(1000);// DEBUG
    stepper1.runSpeed();
    stepsPerSecond = sevoLiq*speedConstant;
    stepper1.runSpeed();
    //Serial.println(stepsPerSecond);
    return stepsPerSecond;
}

float gasFlowRateFunction()
{
    DP = SDP800.getDiffPressure();
    zeroCondition = (sqrt(DP)*constantDP)*(1000.0/60.0);  // SDP trykk
    //les = ads.readADC_SingleEnded(0);
    //zeroCondition = (((les/bitADC)-0.04)/0.09) - CZPO; //MPX5010DP
    return zeroCondition;
}

void fremTilbakeFunction()//float Speed) Det funket men fjernet fordi det ikke brukes.
{
    //stepper1.setCurrentPosition(0); // Kan ikke kjøre denne hvis vi skal kjøre fra bolus. Bolus setter 0-posisjon og kjører 60000. Så går man rett i denne, og beholder posisjonen
        // Så hvis man kjører bolus og havner på 20000, vil denne fortsette derfra og gå frem til 700000
        
    //Serial.println(stepper1.currentPosition()); //Debugging
    nowTime = millis();
    while (z==true){
        if ((millis()-nowTime) > 125 ){
        pressure = SDP800.getDiffPressure();
        Speed = omregningFunction(pressure);
        nowTime = millis();
        }
        
        stepper1.setSpeed(Speed*speedFactor);//2000);//Speed);
        //stepper1.moveTo(3200*58); // beveger seg 58 mm, på 58 sek. Nei. Kjører tre-fire runder
        stepper1.moveTo(1*40000); // (3200/sps)*58 // fra motor
        stepper1.setSpeed(Speed*speedFactor);//2000);//Speed);
        stepper1.runSpeedToPosition();
        if (stepper1.currentPosition() >= 40000){ //185000
            Serial.println("Snur Retning. Går bakover");
            stepper1.setCurrentPosition(0);
            y = true;
            z = false;
            u = false;
            v = false;
            continue;
        }
        
        if(Serial.available()){
                Serial.println("s: stop, p: print patient breath flow rate");
                c = Serial.read();
                if (c == 's'){
                  h = false;
                    stopFunction();
                }
                if (c == 'p'){
                    Serial.print("Gas Flow Rate (ml/s): ");
                    flowRate = gasFlowRateFunction();
                    Serial.println(flowRate);
                    Serial.print("Speed: ");
                    Serial.println(Speed,8);
                    //Serial.print("SDP DP: ");
                    //Serial.println(SDP800.getDiffPressure());
                }
                if (c == 'b'){
                Serial.println("bolus");
                bolus();
                }
            }
    }
     while (y==true){
        if ((millis()-nowTime) > 125 ){
            pressure = SDP800.getDiffPressure();
            Speed = omregningFunction(pressure);
            nowTime = millis();
        }
        stepper1.setSpeed(Speed*speedFactor);//2000);//Speed);
        //stepper1.moveTo(3200*58); // beveger seg 58 mm, på 58 sek. Nei. Kjører tre-fire runder
        stepper1.moveTo(-1*40000); // (3200/sps)*58 // mot motor
        stepper1.setSpeed(Speed*speedFactor);//2000);//Speed);
        stepper1.runSpeedToPosition();
        
        if (stepper1.currentPosition() <= -40000){
            Serial.println("Snur Retning. Går fremover");
            stepper1.setCurrentPosition(0);
            z = true;
            y = false;
            u = false;
            v = false;
            continue;
            
        }
        
        if(Serial.available()){
                Serial.println("s: stop, p: print patient breath flow rate");
                c = Serial.read();
                if (c == 's'){
                     h = false;
                    stopFunction();
                    
                }
                if (c == 'p'){
                    Serial.print("Gas Flow Rate (ml/s): ");
                    flowRate = gasFlowRateFunction();
                    Serial.println(flowRate);
                    Serial.print("Speed: ");
                    Serial.println(Speed,8);
                }
               if (c == 'b'){
                Serial.println("bolus");
                bolus();
                }
            }
     }

}

void initialBolusFunction(){ //denne kjører 5-8 ml/h frem til man trykker på j. Når man trykker på j sendes man til fremTilbakeFunction()
    stepper1.setCurrentPosition(0);
    nowTime = millis();
    while (u==true){
        stepper1.setSpeed(bolusConstant);
        stepper1.moveTo(40000);
        stepper1.setSpeed(bolusConstant);
        
        stepper1.runSpeedToPosition();
        if (stepper1.currentPosition() >= 40000){ //185000
            Serial.println("Snur Retning. Går bakover");
            stepper1.setCurrentPosition(0);
            v = true;
            u = false;
        }
        
        if(Serial.available()){
                Serial.println("s: stop, j: porportional control, p: print patient breath flow rate");
                c = Serial.read();
                if (c == 's'){
                    stopFunction();
                }
                if (c == 'p'){
                    Serial.print("Gas Flow Rate (ml/s): ");
                    flowRate = gasFlowRateFunction();
                    Serial.println(flowRate);
                    Serial.print("Speed: ");
                    Serial.println(Speed,8);
                }
                if (c == 'j'){
                    Serial.print("Kjører etter flow");
                    while (h = true){
                    fremTilbakeFunction();
                    }
                    //z = true;
                    //y = false;
                    //u = false;
                    //v = false;
                    break;
                }
            }
    }
     while (v==true){
        if ((millis()-nowTime) > 125 ){
            pressure = SDP800.getDiffPressure();
            Speed = omregningFunction(pressure);
            nowTime = millis();
        }
        stepper1.setSpeed(bolusConstant);
        stepper1.moveTo(-1*40000);
        stepper1.setSpeed(bolusConstant);
        
        stepper1.runSpeedToPosition();
        if (stepper1.currentPosition() <= -40000){
            Serial.println("Snur Retning. Går fremover");
            stepper1.setCurrentPosition(0);
            //y = true;
            //z = false;
            u = true;
            v = false;
        }
        
        if(Serial.available()){
                Serial.println("s: stop, j: porportional control, p: print patient breath flow rate");
                c = Serial.read();
                if (c == 's'){
                    stopFunction();
                }
                if (c == 'p'){
                    Serial.print("Gas Flow Rate (ml/s): ");
                    flowRate = gasFlowRateFunction();
                    Serial.println(flowRate);
                    Serial.print("Speed: ");
                    Serial.println(Speed,8);
                }
                if (c == 'j'){
                  Serial.print("Kjører etter flow");
                  while (h = true){
                    fremTilbakeFunction();
                    }
                    //z = false;
                    //y = true;
                    
                    //v = false;
                    //u = false;
                    break;
                }
            }
     }
  
  
  }

void bolus(){
    nowTime = millis();
    while ((millis() - nowTime) < bolusTime){
    stepper1.setSpeed(3200);//2000);
    stepper1.runSpeed();
    }
    Serial.println("Bolus ferdig");
    fremTilbakeFunction();
  }
